<?php
/**
 * Envision Multipurpose Theme (2013) - ThemeForest
 * functions.php which does and tells WordPress to load CloudFW and the theme.
 *
 *              (Ya-Settar, Ya-Gaffar, Ya-Fettâh)
 * @author      Wptation
 *              <ticket:    help.wptation.com>
 *              <email:     help@wptation.com>
 *
 * @package     WordPress
 * @subpackage  CloudFw
 * @subpackage  Envision
 */
defined( 'ABSPATH' ) || exit;

/** Defines */
if ( ! defined( 'TMP_PATH' ) ) {
	define( 'TMP_PATH', get_template_directory() . '/' );
}

if ( ! defined( 'TMP_URL' ) ) {
	define( 'TMP_URL', get_template_directory_uri() );
}

if ( ! defined( 'CLOUDFW_TMP_PATH' ) ) {
	define( 'CLOUDFW_TMP_PATH', dirname( __FILE__ ) );
}

/**
 * Load & Run CloudFw
 */
require TMP_PATH . '/cloudfw/cloudfw.loader.php';

function aaptc_add_product_to_cart() {

    if ( ! is_admin() ) {
        // $product_id = 12986;  // Product Id of the free product which will get added to cart
        // $found   = false;
        if ( sizeof( WC()->cart->get_cart() ) <= 0 ) {

// General Donation            
            WC()->cart->add_to_cart( 2936, 10 );
            WC()->cart->add_to_cart( 2937, 10 );
            WC()->cart->add_to_cart( 2960, 10 );
            WC()->cart->add_to_cart( 2961, 10 );
            WC()->cart->add_to_cart( 2962, 10 );
            WC()->cart->add_to_cart( 2963, 10 );
            WC()->cart->add_to_cart( 2964, 10 );
            WC()->cart->add_to_cart( 2965, 10 );

// Endowment Fund
            WC()->cart->add_to_cart( 2938, 10 );
            WC()->cart->add_to_cart( 2966, 10 );
            WC()->cart->add_to_cart( 2967, 10 );
            WC()->cart->add_to_cart( 2968, 10 );
            WC()->cart->add_to_cart( 2969, 10 );
            WC()->cart->add_to_cart( 2970, 10 );
            WC()->cart->add_to_cart( 2971, 10 );
            WC()->cart->add_to_cart( 2972, 10 );

// Development Fund
            WC()->cart->add_to_cart( 2939, 10 );
			
// General Donation            
            // WC()->cart->add_to_cart( 2936 );
            // WC()->cart->add_to_cart( 2937 );
            // WC()->cart->add_to_cart( 2960 );
            // WC()->cart->add_to_cart( 2961 );
            // WC()->cart->add_to_cart( 2962 );
            // WC()->cart->add_to_cart( 2963 );
            // WC()->cart->add_to_cart( 2964 );
            // WC()->cart->add_to_cart( 2965 );

// Endowment Fund
            // WC()->cart->add_to_cart( 2938 );
            // WC()->cart->add_to_cart( 2966 );
            // WC()->cart->add_to_cart( 2967 );
            // WC()->cart->add_to_cart( 2968 );
            // WC()->cart->add_to_cart( 2969 );
            // WC()->cart->add_to_cart( 2970 );
            // WC()->cart->add_to_cart( 2971 );
            // WC()->cart->add_to_cart( 2972 );

// Development Fund
            // WC()->cart->add_to_cart( 2939 );			
        }
    }    
}

add_action( 'init', 'aaptc_add_product_to_cart' );

/**
 * Add the field to the checkout
 */
add_action( 'woocommerce_after_order_notes', 'my_custom_checkout_field' );

function my_custom_checkout_field( $checkout ) {

    echo '<div id="my_custom_checkout_field"><h2>' . __('PAN') . '</h2>';

    woocommerce_form_field( 'pan_num', array(
        'type'          => 'text',
        'class'         => array('my-field-class form-row-wide'),
        'label'         => __('Enter your PAN - mandatory for donation above ₹5000'),
        'placeholder'   => __('ABCDXXXXXX'),
        ), $checkout->get_value( 'pan_num' ));

    echo '</div>';

}

/**
 * Process the checkout
 */
add_action('woocommerce_checkout_process', 'my_custom_checkout_field_process');

function my_custom_checkout_field_process() {
    // Check if set, if its not set add an error.
    if ( WC()->cart->total >= 5000 && ! $_POST['pan_num'] )
        wc_add_notice( __( 'Please enter your PAN, mandatory for donation above ₹5000' ), 'error' );
}

/**
 * Update the order meta with field value
 */
add_action( 'woocommerce_checkout_update_order_meta', 'my_custom_checkout_field_update_order_meta' );

function my_custom_checkout_field_update_order_meta( $order_id ) {
    if ( ! empty( $_POST['pan_num'] ) ) {
        update_post_meta( $order_id, 'PAN', sanitize_text_field( $_POST['pan_num'] ) );
    }
}

/**
 * Display field value on the order edit page
 */
add_action( 'woocommerce_admin_order_data_after_billing_address', 'my_custom_checkout_field_display_admin_order_meta', 10, 1 );

function my_custom_checkout_field_display_admin_order_meta($order){
    echo '<p><strong>'.__('PAN').':</strong> ' . get_post_meta( $order->id, 'PAN', true ) . '</p>';
}